//var hash = window.location.hash.substr(1);

// define media playing property
Object.defineProperty(HTMLMediaElement.prototype, 'playing', {
  get: function() {
    return !!(this.currentTime > 0 && !this.paused && !this.ended && this.readyState > 2);
  }
});

// document ready
$(document).ready(function() {
  if(window.location.hash) {
    $('#head_panel').addClass('smaller');
  }
  // add on scroll function
  window.addEventListener('scroll', function(e) {
    var distanceY = window.pageYOffset || document.documentElement.scrollTop;
    var shrinkOn = 150;
    var topBtnOn = 200;
    if (distanceY > shrinkOn) {
      $('#head_panel').addClass('smaller');
    } else {
      $('#head_panel').removeClass('smaller');
    }
    if (distanceY > topBtnOn) {
      $('#topbtn').css('visibility', 'visible');
      $('#topbtn').css('opacity', '1');
    } else {
      $('#topbtn').css('visibility', 'hidden');
      $('#topbtn').css('opacity', '0');
    }
  });

  // custom scrollTo function
  $.fn.scrollTo = function (adjust) {
      return this.each(function () {
          $('html, body').animate({
              scrollTop: $(this).offset().top + adjust
          }, 500);
      });
  };

  // add on window resize function
  window.addEventListener('resize', function(e) {
    $('.ellipsis').dotdotdot();
  });

  //Click event to scroll to top
  $('#topbtn').click(function() {
    $('html, body').animate({scrollTop : 0}, 300);
    return false;
  });
  
  // jquery ellipsis
  $('.ellipsis').dotdotdot();

  $('#mail_form').submit(function(event) {
    event.preventDefault();
    var form = $(this);
    var url = form.attr('action');
    toggleLoading(form);
    $.post(url, form.serialize(), function(data, status) {
      console.log(status); // debug
      console.log(data); // debug
      result = JSON.parse(data);
      alert(result.msg);
      if (result.res) form.trigger("reset");
    });
    toggleLoading(form);
  });

}); // document ready end

// on click outside vertical menu function
$(document).mouseup(function(e) {
  var vmenu = $("#vmenu");
  var menubtn = $("#menubtn");
  // if the target of the click isn't the menubtn and the vmenu nor a descendant of the vmenu
  if (!menubtn.is(e.target) && (!vmenu.is(e.target) && vmenu.has(e.target).length === 0)) $('#vmenu').hide();
});

function toggleLoading(target) {
  if (target.has('div.ajax-loading').length) target.children('div.ajax-loading').remove();
  else {
    var loading = $("<div />").attr('class', 'ajax-loading');
    target.append(loading);
  }
}

function showMessage(msg) {
  if ($('#messages').length) $('#messages').append(msg);
  else {
    var el = $("<div/>").attr("id", "messages").append(msg);
    $('body').append(el);
  }
}

/**
 * Funkce odesila AJAX request na server
 * @param string url ... url adresa skriptu pro zpracování požadavku
 * @param mixed inputData ... pole obsahujici odesilana data
 * @param string returnDataType ... typ vracenych dat; vychozi je json
 * @param string requestType ... post|get
 * @param string loadingId ... id elementu, ve kterem se zobrazi animace cekani na dokonceni
 * @return mixed 
 */
function ajaxRequest(url, inputData, returnDataType, requestType, loadingId) {
  if (returnDataType==null) returnDataType = 'json';
  if (requestType==null) requestType = 'post';
  if (loadingId!=null) {
    var loading = $("<div />").attr('class', 'ajax-loading');
    $('#'+loadingId).append(loading);
  }
  if (requestType=='get') {
    url += '?';
    var i;
    for (i in inputData) url += i + '=' + inputData[i];
    url = encodeURI(url);
    inputData = null;
  }
  console.log('AJAX url: '+url); //debug
  console.log('AJAX inputData:'); //debug
  console.log(inputData); //debug
  var result;
  try {
    $.ajax({
      type: requestType,
      url: url,
      data: inputData,
      dataType: returnDataType,
      encode: true,
      async: false
    }).done(function(data){
      console.log('AJAX resultData:'); //debug
      console.log(data); //debug
      result = data;
    }).fail(function(data){
      console.log(data.responseText); //debug
      alert(data.responseText);
      result = false;
    });
  } catch (e) {
    alert(e.message);
    console.log(e);
    if (loading) $('#'+loadingId+' .ajax-loading').remove();
    return false;
  }
  if (loading) $('#'+loadingId+' .ajax-loading').remove();
  return result;
}